<?
include_once("ra_api.php");
require_once('config.php');
require_once('common.php');
require_once('RA_domains.php');
$updated_sites = array();

function lmsg($arg){
	err_log($arg);
}

function psa_mysql_query($query = "")
{
	if (!$query)
		return "";
//	echo $query;
	if (false === ($db_res = mysql_query($query))) {
		err_log('Unable to query: '.db_error());
	}
	$result = array();
	while ($row = mysql_fetch_row($db_res))
	{
		$result[] = $row;
	}
	mysql_free_result($db_res);
	return $result;
}
	

class sbm_BaseDomains {
	var $old_name;
	var $new_name;
	var $site_id;
	var $server_id;
	var $ftp_old_login;
	var $ftp_new_login;
	var $ftp_passwd;
	var $workdir;
	function sbm_BaseDomains($old_login, $new_login, $server_id)
	{
		$this->server_id = $server_id;
		$this->ftp_old_login = $old_login;
		$this->ftp_new_login = $new_login;
	}
	
	function update(){
		
		global $updated_sites;
		$tmp = $updated_sites[$this->server_id];
		if ((!isset($tmp)) || (isset($tmp) && !in_array( $this->site_id, $tmp))){
			if ($this->update_sb_host() && $this->update_sb_site()) {
//				err_log("===> ".$res1->get_content());
//				err_log("===> ".$res2->get_content);
				return true;
			}	else {
/*				err_log("X===>".$res1['MESSAGE']);
				err_log("X===>".$res2['MESSAGE']);
*/				return false;
			}
		}
		return true;
	}
	
	
	function update_sb_host ()
	{
		if ($this->old_name != '' && $this->new_name != '' && $this->old_name != $this->new_name){
			$host = new RA_Hosts();
			$id = $this->old_name;
			$attr = &$host->list[$id];
			$attr['HOST_NAME'] = $this->new_name;
			$attr['ACTIVE'] = 1;
			$host->update($id);
			err_log(">".$host->error['MESSAGE']);
			if ($host->error()){
			//	err_log("X===> ".$host->error['MESSAGE']);
				return false;
			}
			return $host->result;
		} else
			return true;
	}

	function update_sb_site ()
	{
		global $updated_sites;
		if ($this->ftp_new_login != '') {
			$site = new RA_Sites();
			$id = $this->ftp_old_login."_".str_replace(array('.', '@'), "_", $this->old_name)."_site";
			$new_id = $this->ftp_new_login."_".str_replace(array('.', '@'), "_", $this->new_name)."_site";
			$post = array(
				'sb_old_siteid'	=>	$id,
				'sb_siteid'	=>	$new_id,
				'sb_pswd'	=>	$this->ftp_passwd,
				'sb_pswd_conf'	=>	$this->ftp_passwd,
				'sb_host_name'	=> $this->new_name,
				'sb_ftp_host'	=>	$this->new_name,
				'sb_ftp_login'	=>	$this->ftp_new_login,
				'sb_ftp_pass'	=>	$this->ftp_passwd,
				'sb_ftp_workdir'	=>	$this->workdir,
				'PlanHost'	=>	$this->new_name,
			);
			$site->send_command('update_site', $post);
			err_log("=> ".$this->new_name.": ".$site->error['MESSAGE']);
			if ($site->error()){
				$cmd = check_result($site->error());
				if ($cmd != 2){
//					err_log("X===> ".$this->new_name.": ".$site->error['MESSAGE']);
					return false;
				}
			}
			$this->site_id = $site->result->get_content();
			array_push($updated_sites[$this->server_id], $this->site_id);
			return $site->result;
		} else
			return false;
	}
	
}    

class sbm_SubDomains extends sbm_BaseDomains {
	var $domain_name;
	var $new_subdomain;
	var $subdom_id;
	var $sys_user_type;
	
	function sbm_SubDomains($dom_name, $old_login, $new_login, $old_subname, $new_subname, $server_id)
	{
		parent::sbm_BaseDomains($old_login,$new_login,$server_id);
		$this->domain_name = $dom_name; 
		$this->new_subdomain = $new_subname;
		$this->get_subdom_details();
		$this->old_name = $old_subname.".".$dom_name;
		$this->new_name = $new_subname.".".$dom_name;
		$this->workdir = ($this->sys_user_type == 'main')?'subdomains/'.$this->new_subdomain.'/httpdocs':'httpdocs';
		$ftp_account = get_sd_ftp_user($this->subdom_id);
		$this->ftp_passwd = $ftp_account[1];
	}

	function get_subdom_details()
	{
		if ($this->subdom_id == "") {
			$query = "SELECT ".RA_TBL_DOMAINS.".subdom_id, subdomains.dom_id, ".RA_TBL_DOMAINS.".site_identity, 
				subdomains.sys_user_type FROM ".RA_TBL_DOMAINS." 
				LEFT JOIN subdomains ON ".RA_TBL_DOMAINS.".subdom_id=subdomains.id
				LEFT JOIN domains ON subdomains.dom_id = domains.id
				WHERE domains.name ='".$this->domain_name."'
				AND subdomains.name='".$this->new_subdomain."'
				AND ".RA_TBL_DOMAINS.".sb_server_id = '".$this->server_id."'";
			if ($resp = psa_mysql_query($query)){
				$this->subdom_id = $resp[0][0];
				$this->dom_id = $resp[0][1];
				$this->site_id = $resp[0][2];
				$this->sys_user_type = $resp[0][3];
			}
		}
	}
	
	function get_site_id()
	{
		if ($this->site_id)
			return $this->site_id;
		else
			$this->get_subdom_details();
		return $this->site_id;

	}
	
	function delete()
	{
		subdomains_deny_access($this->subdom_id);
	}

}

class sbm_Domains extends sbm_BaseDomains {
	
	var $dom_id;
	var $subdomains;
	
	//Needed for Base:	$old_name; $new_name; $site_id; 
	//$server_id; $ftp_old_login; $ftp_new_login; $ftp_passwd; $workdir;

	//Needed for subdomains: $dom_name, $old_login, $new_login, $old_subname, $new_subname, $server_id
	
	function sbm_Domains($old_name, $new_name, $old_login, $new_login, $server_id)
	{
		parent::sbm_BaseDomains($old_login, $new_login, $server_id);
		$this->old_name = $old_name;
		$this->new_name = $new_name;
		$this->workdir = 'httpdocs';
		$this->get_domain_details();
		$this->ftp_passwd = get_ftp_passwd($this->dom_id);
		$this->get_subdomains();
//		var_dump($this);		
	}
	
	
	function get_domain_details()
	{
		$query = "SELECT domains.id, ".RA_TBL_DOMAINS.".site_identity FROM ".RA_TBL_DOMAINS." 
			LEFT JOIN domains ON ".RA_TBL_DOMAINS.".domain_id = domains.id
			WHERE domains.name ='".$this->new_name."'
			AND ".RA_TBL_DOMAINS.".sb_server_id = '".$this->server_id."'";
		if ($resp = psa_mysql_query($query)){
			$this->dom_id = $resp[0][0];
			$this->site_id = $resp[0][1];
		}
	}
	
	function get_subdomains ($all = NULL)
	{
		$query = "SELECT subdomains.name, ".RA_TBL_DOMAINS.".sb_server_id FROM ".RA_TBL_DOMAINS." 
			LEFT JOIN subdomains ON ".RA_TBL_DOMAINS.".subdom_id=subdomains.id 
			LEFT JOIN domains on domains.id=subdomains.dom_id 
			WHERE domains.name ='".$this->new_name."' ";
		$query .= (is_null($all)) ? "AND subdomains.sys_user_type='main';" : ";";
		if (false === ($db_res = mysql_query($query))) {
			err_log('Unable to query: '.db_error());
		}
		$result = &$this->subdomains;
		$db_row = array();
		if (!is_null($all)) $result = array();
		while ($db_row = mysql_fetch_row($db_res))
		{
			$sub_domain = new sbm_SubDomains($this->new_name, $this->ftp_old_login, $this->ftp_new_login, $db_row[0], $db_row[0], $db_row[1]);
			$result[] = $sub_domain;
		}
		mysql_free_result($db_res);
	}

	function update()
	{
		global $server;
		parent::update();
		$url = "/modules/sbm2/open_sb.php?sb_server=".substr($server['name'], 0, strpos($server['name'],'remote_admin/')).'&siteid='.$this->site_id."&pswd=".$this->ftp_passwd;
		cb_clean($this->dom_id, $url);
		cb_icon_create($this->new_name, $url);
	}

	function update_resellers()
	{
		global $server;
		if ($reseller_id = get_reseller_id($this->dom_id)){
			$url = '/modules/sbm2/index.php?sb_server='.$server['name'].'&ra_cmd=main&pswd';
			cb_clean($this->dom_id, $url);
			$url = '/modules/sbm2/index.php?sb_server='.$server['name'].'&ra_cmd=main&ftp_user='.$this->ftp_new_login.'&ftp_pass='.$this->ftp_passwd;
			sbm_create_button($this->new_name, $url);
			$query = "UPDATE ".RA_TBL_RESELLERS." SET sb_login = '$this->ftp_new_login' WHERE id = '$reseller_id';";
			if (!mysql_query($query)){
				err_log("===> Can't access to database while updating resellers");
			}
		}
	}
	
	function delete()
	{
		clients_deny_access($this->dom_id);
		resellers_deny_access($this->dom_id);
	}
	
}

function psa_mysql_connect()
{
	global $PSA_CONFIG;
	if ($PSA_CONFIG['DEMO_VERSION'] == "yes")
		define('PRODUCT_DEFAULT_PASSWORD' , 'plesk');
	else
		define('PRODUCT_DEFAULT_PASSWORD' , 'setup');

	if (false === ($mysql_passwd = str_replace("\n","",file_get_contents("/etc/psa/.psa.shadow"))))
		$mysql_passwd = PRODUCT_DEFAULT_PASSWORD;
	
	$link = mysql_connect('localhost', 'admin', $mysql_passwd) or err_log('Could not connect: ' . mysql_error());
	mysql_select_db('psa') or err_log('Could not select database');
	return $link;	
}

function err_log($err_msg='')
{
//	echo "$err_msg\n";
	
	global $PSA_CONFIG;
	$logfile = $PSA_CONFIG['PRODUCT_ROOT_D']."/admin/plib/modules/sbm2/update_hosting.log";
	if ((UPDATING_LOG) && ($handle = fopen($logfile, 'a')) && $err_msg)
	{
		$err_str = strftime("%c%t").$err_msg."\n";
		fwrite($handle, $err_str) || die("Can't write to log");
		fclose($handle);
	} else
	    echo "$err_msg\n";
}


         
function check_access($domain, $sub="")
{
	$query = ($sub) ? "SELECT sb_server_id FROM ".RA_TBL_DOMAINS." 
		LEFT JOIN subdomains on subdomains.id=".RA_TBL_DOMAINS.".subdom_id 
		LEFT JOIN domains on subdomains.dom_id=domains.id 
		WHERE domains.name='$domain' AND subdomains.name='$sub'"
	 : "SELECT sb_server_id FROM ".RA_TBL_DOMAINS." 
	 	LEFT JOIN domains on domains.id=".RA_TBL_DOMAINS.".domain_id
	 	WHERE domains.name='$domain'";
	$result = psa_mysql_query($query);
//	var_dump($result);
	if ($result)
		return $result;
	else
		return false;
}

function check_resellers($domain)
{
	$query ="SELECT sb_server_id FROM ".RA_TBL_RESELLERS." 
	 	LEFT JOIN domains on domains.id=".RA_TBL_RESELLERS.".domain_id
	 	WHERE domains.name='$domain'";
	$result = psa_mysql_query($query);
//	var_dump($result);
	if ($result)
		return $result;
	else
		return false;
}


global $argv;
global $ERRS;
global $server;
global $updated_sites;
$updated_sites = array();
if ($argv){
//	var_dump($argv);
	$PSA_CONFIG = read_psa_conf();
	define ("PRODUCT_ROOT", $PSA_CONFIG['PRODUCT_ROOT_D']);
	define ('PLIB_PATH', PRODUCT_ROOT."/admin/plib/modules/sbm2");
	include (PRODUCT_ROOT."/admin/htdocs/modules/sbm2/curl_send.php");
	require_once('RA_psa_resellers.php');
	$db_link = psa_mysql_connect();
	$server = sbm_get_current_server();
	$_SESSION['server'] = $server;
	switch ($argv[1]){
	
			case "update_hosting":
			{
				$old_name = $argv[2];
				$new_name = $argv[3];
				$old_login = $argv[4];
				$new_login = $argv[5];

				if ($sb_servers_list = check_access($new_name)){
//					var_dump($sb_servers_list);
					foreach ($sb_servers_list as $server_id) {
						$server_id = $server_id[0];
						$server = sbm_get_current_server($server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						err_log("===> Updating domain ".$old_name." for server ".$server['name']);
						$domain = new sbm_Domains($old_name, $new_name, $old_login, $new_login, $server_id);	
						$domain->update();
					}
				}

				if ($servers_list = check_resellers($new_name)){
					foreach ($sb_servers_list as $server_id) {
						$server_id = $server_id[0];
						$server = sbm_get_current_server($server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						err_log("===> Updating Reseller for domain user ".$old_name." at server ".$server['name']);
						$domain = new sbm_Domains($old_name, $new_name, $old_login, $new_login, $server_id);
						$domain->update_resellers();
					}
				}

				$domain = new sbm_Domains($old_name, $new_name, $old_login, $new_login, $server['id']);
				foreach ($domain->subdomains as $subdomain) {
						$server = sbm_get_current_server($subdomain->server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						err_log("  ===> Updating subdomain ".$subdomain->new_subdomain.".".$subdomain->domain_name);
						$subdomain->update();
				}

				break;
			}
			
			case "update_subdomain":
			{
				$old_subname = $argv[2];
				$new_subname = $argv[3];
				$domain_name = $argv[4];
				$old_login = $argv[5];
				$new_login = $argv[6];
				if ($sb_servers_list = check_access($domain_name, $new_subname)){
					foreach ($sb_servers_list as $server_id) {
						$server_id = $server_id[0];
						$server = sbm_get_current_server($server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						$subdomain = new sbm_SubDomains($domain_name, $old_login, $new_login, $old_subname, $new_subname, $server_id);
						err_log("  ===> Updating subdomain ".$subdomain->new_subdomain.".".$subdomain->domain_name);
						$subdomain->update();
					}
				}
				break;
			}
			
			case "delete_domain":
			{
				$old_name = $argv[2];
				$new_name = $old_name;
				$old_login = "";
				$new_login = "";
				if ($sb_servers_list = check_access($new_name)){
//					var_dump($sb_servers_list);
					foreach ($sb_servers_list as $server_id) {
						$server_id = $server_id[0];
						$server = sbm_get_current_server($server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						err_log("===> Deleting domain ".$old_name." for server ".$server['name']);
						$domain = new sbm_Domains($old_name, $new_name, $old_login, $new_login, $server_id);	
						$domain->delete();
					}
				}
				if ($servers_list = check_resellers($new_name)){
					foreach ($sb_servers_list as $server_id) {
						$server_id = $server_id[0];
						$server = sbm_get_current_server($server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						err_log("===> Deleting Reseller for domain user ".$old_name." at server ".$server['name']);
						$domain = new sbm_Domains($old_name, $new_name, $old_login, $new_login, $server_id);
						$domain->update_resellers();
					}
				}
				$domain = $domain = new sbm_Domains($old_name, $new_name, $old_login, $new_login, $server['id']);
				$domain->get_subdomains("all");
//				var_dump($domain);
				foreach ($domain->subdomains as $subdomain) {
							$server = sbm_get_current_server($subdomain->server_id);
							$_SESSION['server'] = $server;
							if (!SB_check_server($server))
								continue;
							err_log("  ===> Deleting subdomain ".$subdomain->new_subdomain.".".$subdomain->domain_name);
							$subdomain->delete();
						}
				break;
			}

			case "delete_subdomain":
			{
				$old_subname = $argv[2];
				$new_subname = $argv[2];
				$domain_name = $argv[3];
				$old_login = "";
				$new_login = "";
				if ($sb_servers_list = check_access($domain_name, $new_subname)){
					foreach ($sb_servers_list as $server_id) {
						$server_id = $server_id[0];
						$server = sbm_get_current_server($server_id);
						$_SESSION['server'] = $server;
						if (!SB_check_server($server))
							continue;
						$subdomain = new sbm_SubDomains($domain_name, $old_login, $new_login, $old_subname, $new_subname, $server_id);
						err_log("  ===> Deleting subdomain ".$subdomain->new_subdomain.".".$subdomain->domain_name);
						$subdomain->delete();
					}
				}
				break;
			}
	}
	
	mysql_close($db_link);
}

?>
