<?
    
function get_domain_id ($ftp_user)
{
	$query = "select hosting.dom_id from hosting left join sys_users on hosting.sys_user_id=sys_users.id where sys_users.login='".$ftp_user."';";
	$domain_id = sbm_string_query($query);
	if ($domain_id)
		return $domain_id;
	else
		return false;
}


function RA_show_clients()
{
	global $server;
	if ($_SESSION['user_role'] == 'root' ){
		$dom_id = "";	
	}else
		$dom_id = get_domain_id(substr($server['username'], 0, strpos($server['username'], '@')));
	
	include_once('class.DomainList.php');
	$page = 0;
	$dom_list =new DomainList($server['id']);
	$dom_list->resetError_();

	$res = $dom_list->getPageHeader();
	
	// fetch list
	$dom_list->fetchDomainList($dom_id);
	if ($dom_list->error())
		return false;

	$dom_list->applayFilter_();
	if ($dom_list->error())
		return false;

		$dom_list->applaySort_();
	if ($dom_list->error())
		return false;

	$dom_list->setPageSize($_SESSION['page_size']);
	$page = ($dom_list->filter_ == '')? $_SESSION['page']:0;
	$dom_list->setPage($page);
	$dom_list->applayPage_();	
	
	$res .= $dom_list->get_table();
	$res .= $dom_list->get_bottom();
	
	return $res;

}

function sb_synchronize()
{
	return true;
}


function check_result($result)
{
	global $stat_msg;
	
	if (!$result['CODE'])
		return false;
	$license_limits = array('010046', '060002', '060008', '060025', '000002');
	
	$good = array(
		//HOST OK Codes	
		'060004', '060013', '070058', '060009', '060029',
		//SITES OK Codes
		'010041', '010047', '010048', '010056', '010070',
		
		//Resellers OK Codes
		'070003', '070005', '070013' );
	
		if (in_array($result['CODE'], $license_limits)){
				$stat_msg .= lmsg('RA__msg_license_limit').': '.$result['MESSAGE'].'. ';
				return 1;
		} elseif (in_array($result['CODE'], $good)){
				return 2;
		} else {
			//$stat_msg .= lmsg('RA__msg_err_add_sbhost').": ".$result['MESSAGE'].'. ';
			return 0;
		}

}

function subdomains_allow_access($subdom_list)
{
	global $stat_msg;
	global $server;
	$result="";
	if (strpos($subdom_list, ',')) $subdom_list = substr($subdom_list, 0, -1);
	$subdomain_list = split(',' , $subdom_list);
	foreach ($subdomain_list as $subdomain_id) {
		list($ftp_user, $ftp_passwd) = get_sd_ftp_user($subdomain_id);
		list($subdom_name, $usr_type, $sd_short_name) = get_subdomain_name($subdomain_id);
		$work_dir = ($usr_type == 'main')?'subdomains/'.$sd_short_name.'/httpdocs':'httpdocs';
		$site_alias = str_replace(array('.', '@'), '_', $server['username']."_".$subdom_name."_site");
		if (check_site_id($subdomain['domain_id'], $subdom_name)){
			continue;
		}

		$result = add_sb_host($subdom_name);

		if ($result->error()){
			$cmd = check_result($result->error());
			if ($cmd == 0){
				$stat_msg .= lmsg('RA__msg_err_add_sbhost')." '$subdom_name': ".$result->error['MESSAGE'].". ";
				continue;
			}elseif ($cmd == 1){
				return;
			}
		}
		
		$result = add_sb_site($site_alias, $subdom_name, $ftp_user, $ftp_passwd, $work_dir);
		if ($result->error()){
			if ('010046' == $result->error['CODE']){
				$stat_msg = lmsg('RA__msg_license_limit').'. ';
				$result = delete_sb_host($subdom_name);
				return;
			}
			$cmd = check_result($result->error());
			if ($cmd == 0){
				$stat_msg .= $stat_msg .= lmsg('RA__msg_err_add_sbsite').": ".$result->error['MESSAGE'].". ";
				continue;
			}elseif ($cmd == 1)
				return;
		}	
		$site_id = $result->result->get_content();
		if ($site_id != ""){
			$query = "DELETE FROM ".RA_TBL_DOMAINS." 
			WHERE site_identity='$site_alias' AND sb_server_id = '".$server['id']."';";
			if (!mysql_query($query)){
				psaerror('Unable to query: '.db_error());
				$stat_msg = lmsg('RA__msg_err').db_error();
			}
			$query = "INSERT INTO ".RA_TBL_DOMAINS." SET subdom_id = '$subdomain_id',
				domain_id=0, site_identity='$site_alias', sb_server_id = '".$server['id']."';";
			if (!mysql_query($query)){
				psaerror('Unable to query: '.db_error());
				$stat_msg = lmsg('RA__msg_err').db_error();
			}
		} else 
			$stat_msg .= lmsg('RA__msg_err_add_domain').$subdom_name;
	}

}

function subdomains_deny_access($subdom_list)
{
	global $stat_msg;
	global $server;
	if (strpos($subdom_list, ',')) $subdom_list = substr($subdom_list, 0, -1);
	$subdomain_list = split(',' , $subdom_list);
	foreach ($subdomain_list as $subdomain_id) {
		list($subdom_name) = get_subdomain_name($subdomain_id);
		$site_alias = check_site_id("0", $subdom_name);
		if ($site_alias === false) continue;
		
		if (false == delete_sb_site($site_alias)){
			$stat_msg .= lmsg('RA__msg_err_del_site')." '$subdom_name': ";
			continue;
		}

		if (false == delete_sb_host($subdom_name)){
			$stat_msg .= lmsg('RA__msg_err_del_host')." '$subdom_name': ";
			continue;
		}
		
		$query = 'DELETE FROM '.RA_TBL_DOMAINS.' WHERE site_identity = \''.$site_alias.'\' AND sb_server_id= \''.$server['id'].'\';';
		if (!mysql_query($query)){
			psaerror('Unable to query: '.db_error());
			$stat_msg=lmsg('RA__msg_err').db_error();
			continue;
		}


	}
	//	$stat_msg .= '\''.$result.'\' ';
}


function clients_allow_access($dom_list)
{
	global $stat_msg;
	global $server;
	$work_dir = 'httpdocs';
	$result="";
	if (strpos($dom_list, ',')) $dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		$ftp_user = get_ftp_user($domain_id);
		$ftp_passwd = get_ftp_passwd($domain_id);
		$dom_name = get_domain_name($domain_id);
		$site_alias = str_replace(array('.', '@'), '_', $server['username']."_".$dom_name."_site");
		if (check_site_id($domain_id, $dom_name)){
			continue;
		}

		$result = add_sb_host($dom_name);

		if ($result->error()){
			$cmd = check_result($result->error());
			if ($cmd == 0){
				$stat_msg .= lmsg('RA__msg_err_add_sbhost')." '$dom_name': ".$result->error['MESSAGE'].". ";
				continue;
			}elseif ($cmd == 1){
				return;
			}
		}
		$result = add_sb_site($site_alias, $dom_name, $ftp_user, $ftp_passwd, $work_dir);
		if ($result->error()){
			$rst = delete_sb_host($dom_name);
			if ($result->error['CODE'] == '010046'){
				$stat_msg = lmsg('RA__msg_license_limit').'. ';
				return;
			}
			$cmd = check_result($result->error());
			if ($cmd == 0){
				$stat_msg .= lmsg('RA__msg_err_add_sbsite').": ".$result->error['MESSAGE'].". ";
				continue;
			}elseif ($cmd == 1)
				return;
		}	
		$site_id = $result->result->get_content();
		if ($site_id != ""){
			$url = "/modules/sbm2/open_sb.php?sb_server=".substr($server['name'], 0, strpos($server['name'],'remote_admin/')).'&siteid='.$site_id."&pswd=".$ftp_passwd;
			cb_clean($domain_id, $url);
			cb_icon_create($dom_name, $url);
	
			$query = "DELETE FROM ".RA_TBL_DOMAINS." WHERE site_identity='$site_alias' AND sb_server_id = '".$server['id']."';";
			if (!mysql_query($query)){
				psaerror('Unable to query: '.db_error());
				$stat_msg = lmsg('RA__msg_err').db_error();
			}
	
			$query = " INSERT INTO ".RA_TBL_DOMAINS." SET domain_id='$domain_id',
			 subdom_id=0, site_identity='$site_alias', sb_server_id = '".$server['id']."';";
			if (!mysql_query($query)){
				psaerror('Unable to query: '.db_error());
				$stat_msg = lmsg('RA__msg_err').db_error();
			}
		} else 
			$stat_msg .= lmsg('RA__msg_err_add_domain').$dom_name;
	}
	
}
function cb_icon_create($dom_name, $url)
{
	global $server;
	$owner = $server['username'];
	$img_path = PRODUCT_ROOT.'/admin/htdocs/modules/sbm2/images/icon.gif';
	$cb_tool =PRODUCT_ROOT."/bin/custombutton.sh";
	$rst=`$cb_tool --create -owner "$dom_name" -place "domain" -text "SiteBuilder2 ($owner)" -url "$url" -conhelp "SiteBuilder2" -file $img_path`;
	if ($rst)
		return $rst;
	else
		return false;
}



function clients_deny_access($dom_list)
{
	global $stat_msg;
	global $server;

	if (strpos($dom_list, ',')) $dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		$dom_name = get_domain_name($domain_id);
		$ftp_passwd = get_ftp_passwd($domain_id);
		$site_alias = check_site_id($domain_id, $dom_name);
		if (!$site_alias)
			continue;
		$site_identity = get_sb_site_id($site_alias);
		$url = "/modules/sbm2/open_sb.php?sb_server=".substr($server['name'], 0, strpos($server['name'],'remote_admin/')).'&siteid='.$site_identity."&pswd=".$ftp_passwd;
		cb_clean($domain_id, $url);
		if (false == delete_sb_site($site_alias)){
			$stat_msg .= lmsg('RA__msg_err_del_site')." '$dom_name': ";
			continue;
		}

		if (false == delete_sb_host($dom_name)){
			$stat_msg .= lmsg('RA__msg_err_del_host')." '$dom_name': ";
			continue;
		}
		
		$query = 'DELETE FROM '.RA_TBL_DOMAINS.' WHERE site_identity = \''.$site_alias.'\' AND sb_server_id= \''.$server['id'].'\';';
		if (!mysql_query($query)){
			psaerror('Unable to query: '.db_error());
			$stat_msg=lmsg('RA__msg_err').db_error();
		}
	}
}

function cb_clean($dom_id, $url)
{
	global $stat_msg;
	$cb_tool = PRODUCT_ROOT."/bin/custombutton.sh";
	if (strpos($url, "&pswd")){
		$url = substr($url, 0, strpos($url, "&pswd"));
		$url = str_replace("_", "\_", $url);
		$url = str_replace("%", "\%", $url);
		$query = "SELECT id FROM custom_buttons WHERE level_id = '$dom_id' AND url LIKE '$url%';";
	} else 
		$query = "SELECT id FROM custom_buttons WHERE level_id = '$dom_id' AND url = '$url';";
	
	if (false === ($res = mysql_query($query))){
		psaerror('Unable to query: '.db_error());
		$stat_msg = lmsg('RA__msg_err').db_error();
	}
	while (list($cb_id) = mysql_fetch_row($res)){
		`$cb_tool --remove $cb_id`;
	}
	return;
}

function add_sb_site($site_id, $host, $login, $passwd, $work_dir="")
{
	global $server;
	$site_id = str_replace(array('.', '@'), '_', $site_id);
	$root_login = sbm_get_root_login();
	$base_plan = ($server['username'] == $root_login) ? "BasePlan" : "BasePlan_".$login.'@'.$host;
	$post = array(
		'sb_site_type'	=>	'REGULAR',
		'sb_siteid'	=>	$site_id,
		'sb_active'	=>	1,
		'sb_plan'	=>	$base_plan,
		'sb_pswd'	=>	$passwd,
		'sb_pswd_conf'	=>	$passwd,
		'sb_publish'	=>	1,
		'sb_host_name'	=> $host,
		'sb_mode'	=>	'ftp',
		'sb_ftp_host'	=>	$host,
		'sb_ftp_login'	=>	$login,
		'sb_ftp_pass'	=>	$passwd,
		'sb_ftp_workdir'	=>	$work_dir,
		'PlanHost'	=>	$host,
	);

	$site = new RA_Sites();
	$site->send_command('create_site', $post);
	return $site;
}

function delete_sb_site($site_id)
{
	$site = new RA_Sites();
	$site->delete($site_id);
    return $site;
}

function add_sb_host($hostname)
{
	$host = new RA_Hosts();
	$attr = &$host->list[NEW_ID];
	$attr['HOST_NAME'] = $hostname;
	$attr['ACTIVE']	= 1;
	$host->add(NEW_ID);
    return $host;
}

function delete_sb_host($hostname)
{
	$host = new RA_Hosts();
	$host->delete($hostname);
    return $host;
}


function get_sd_ftp_user($subdom_id)
{
	global $stat_msg;
	$result = array();
	$query = 'SELECT sys_users.login, accounts.password FROM sys_users LEFT JOIN subdomains ON sys_users.id=subdomains.sys_user_id LEFT JOIN accounts on sys_users.account_id = accounts.id WHERE subdomains.id=\''.$subdom_id.'\';';
	if (false === ($res = mysql_query($query))){
		psaerror('Unable to query: '.db_error());
		$stat_msg=lmsg('RA__msg_err').db_error();
	}
	$result = mysql_fetch_row($res);
	mysql_free_result ($res);
	return $result;
}

function get_subdomain_name($dom_id)
{
	global $stat_msg;
	$query = 'SELECT subdomains.name, domains.name, subdomains.sys_user_type FROM subdomains LEFT JOIN domains on subdomains.dom_id = domains.id WHERE subdomains.id=\''.$dom_id.'\';';
	
	if (false === ($res = mysql_query($query))){
		psaerror('Unable to query: '.db_error());
		$stat_msg=lmsg('RA__msg_err').db_error();
	}
	list($subdomain, $domain, $user_type) = mysql_fetch_row($res);
	mysql_free_result ($res);
	return array($subdomain.'.'.$domain, $user_type, $subdomain);
}


function get_ftp_user($dom_id)
{
	$query = 'SELECT login FROM sys_users LEFT JOIN hosting ON sys_users.id=hosting.sys_user_id WHERE hosting.dom_id=\''.$dom_id.'\';';
	$login = sbm_string_query($query);
	if ($login != "")
		return $login;
	else
		return false;
}


function get_domain_name($dom_id, $get_ip=false)
{
	global $stat_msg;
	$query = 'SELECT name FROM domains WHERE id=\''.$dom_id.'\';';
	
	if ($get_ip) //Get ip-address instead
		$query  = "SELECT ip_address FROM IP_Addresses LEFT JOIN hosting ON IP_Addresses.id = hosting.ip_address_id WHERE dom_id=".$dom_id.";";
	
	$domain = sbm_string_query($query);
	return $domain;
}

//--------------------------------------------------

function check_site_id($domain_id, $domain_name = "")
{
	global $server;
	if ($domain_name == "") $domain_name = get_domain_name($domain_id);
	$site_alias = str_replace(array('.', '@'), '_', $server['username']."_".$domain_name."_site");
	$query = "SELECT site_identity FROM ".RA_TBL_DOMAINS." WHERE sb_server_id ='".$server['id']."' AND domain_id ='".$domain_id."';";
	if (false === ($res = mysql_query($query))){
		psaerror('Unable to query: '.db_error());
		$stat_msg=lmsg('RA__msg_err').db_error();
	}
	while (list($site_id) = mysql_fetch_row($res)){
		if ($site_id == $site_alias)
			return $site_id;
	}

	return false;
}
//function get_site_id($domain_id, $subdom_id = "")
//{
//	global $stat_msg;
//	global $server;
//	$site_id = '';
//	if ($subdom_id == "") 
//		$where = 'domain_id=\''.$domain_id.'\';';
//	else
//		$where = 'subdom_id=\''.$subdom_id.'\';';
//	
//	$query = "SELECT site_identity FROM ".RA_TBL_DOMAINS." WHERE sb_server_id ='".$server['id']."' AND ".$where;
//	$site_id = sbm_string_query($query);
//
//	if ($site_id != '')
//		return $site_id;
//	else
//		return false;
//}
//
function get_ftp_passwd($dom_id)
{
	
	$query = 'SELECT accounts.password FROM accounts LEFT JOIN sys_users ON sys_users.account_id=accounts.id  LEFT JOIN hosting ON sys_users.id=hosting.sys_user_id WHERE hosting.dom_id=\''.$dom_id.'\';';
	$passwd = sbm_string_query($query);
	return $passwd;
}

function get_sb_site_id($site_alias)
{
	$site = new RA_Sites();
	$site->get_details($site_alias);
    if (!$site->error()){
            $site->parse_details();
            return $site->site[$site_alias]['SITE_IDENTITY'];
	}
    return $site_alias;
}

?>
