<?
function RA_show_resellers()
{
	include_once('class.PleskResellersList.php');
	$page = 0;
	$dom_list =new PleskResellersList($_SESSION['server']['id']);
	$dom_list->resetError_();

	$res = $dom_list->getPageHeader();
	// fetch list
	$dom_list->fetchList();
	if ($dom_list->error())
		return false;

	$dom_list->applayFilter_();
	if ($dom_list->error())
		return false;

		$dom_list->applaySort_();
	if ($dom_list->error())
		return false;

	$page_size = $_SESSION['sbm_psa_resellers_page_size'];
	$page_size = ($page_size || $page_size == 0) ? 10 : $page_size;
	$dom_list->setPageSize($page_size);
	$page = ($dom_list->filter_ == '')? $_SESSION['sbm_psa_resellers_page']:0;
	$dom_list->setPage($page);
	$dom_list->applayPage_();	
	
	$res .= $dom_list->get_table();
	$res .= $dom_list->get_bottom();
	
	return $res;
}

function add_hosts($domain_id)
{
	global $server;
	require_once('class.DomainList.php');
	//$hosts_list = get_domain_name($domain_id);
	$domain = new DomainList($server['id']);
	$domain->fetchDomainList($domain_id);
	foreach ($domain->list_ as $subdomain)
	{
		$hosts_list .= $subdomain['name'];
		$result = add_sb_host($subdomain['name']);
		if ($result->error()){
			$cmd = check_result($result->error());
			if ($cmd == 0){
				$stat_msg .= lmsg('RA__msg_err_add_sbhost')." '$dom_name': ".$result->error['MESSAGE'].". ";
				continue;
			}elseif ($cmd == 1){
				return;
			}
		}

	}
}



function resellers_allow_access($dom_list)
{
	global $stat_msg;
	global $server;
	$result="";
	if (strpos($dom_list, ',')) $dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		if (get_reseller_id($domain_id))
			continue;
		$dom_name = get_domain_name($domain_id);
		$dom_ftp_user = get_ftp_user($domain_id);
		$dom_passwd = get_ftp_passwd($domain_id);
		add_hosts($domain_id);

		$sites_limit = get_sites_limit($domain_id);
		$result = sbm_add_reseller($dom_name, $dom_ftp_user, $dom_passwd, $sites_limit);

		if ($result->error()){
			$cmd = check_result($result->error());
			if ($cmd == 0){
				$stat_msg .= lmsg('RA__msg_err_add_reseller')." '$dom_name': ".$result->error['MESSAGE'].". ";
				continue;
			}elseif ($cmd == 1){
				return;
			}
		}
		$url = '/modules/sbm2/index.php?sb_server='.$server['name'].'&ra_cmd=main&pswd';
		cb_clean($domain_id, $url);
		$url = '/modules/sbm2/index.php?sb_server='.$server['name'].'&ra_cmd=main&ftp_user='.$dom_ftp_user."@".$dom_name.'&ftp_pass='.$dom_passwd;
		sbm_create_button($dom_name, $url);
		$query = 'REPLACE INTO '.RA_TBL_RESELLERS.' SET domain_id = \''.$domain_id.'\', sb_server_id = \''.$server['id'].'\''.", sb_login = '$dom_ftp_user';";
		if (!mysql_query($query)){
			psaerror('Unable to query: '.db_error());
			$stat_msg = lmsg('RA__msg_err').db_error();
		}

		//$stat_msg .= ' \''.$result.'\' ';
	}
	
}

function resellers_deny_access($dom_list)
{
	global $stat_msg;
	global $server;
	$result="";
	if (strpos($dom_list, ',')) 
		$dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		if (!get_reseller_id($domain_id))
			continue;
		$url = '/modules/sbm2/index.php?sb_server='.$server['name'].'&ra_cmd=main&pswd';
		cb_clean($domain_id, $url);
		$host_str .= get_domain_name($domain_id).",";
		$dom_str .= get_reseller_sb_login($domain_id)."@".$host_str.",";
		
	}
	if ($dom_str == "")
		return;
	
	$result = sbm_delete_resellers(substr($dom_str, 0, -1));

	if ($result->error()){
		$cmd = check_result($result->error());
	
		if ($cmd == 0){
			$error = $result->error();
			$stat_msg .= lmsg('RA__msg_err_del_reseller')." '$dom_name': ".$error['MESSAGE'].'. ';
		}elseif ($cmd == 1){
			return;
		}
	}
	
	$dom_list = str_replace(",", "' OR domain_id ='", $dom_list);
	$query = 'DELETE FROM '.RA_TBL_RESELLERS.' WHERE domain_id = \''.$dom_list.'\' AND sb_server_id= \''.$server['id'].'\';';
	if (!mysql_query($query)){
		psaerror('Unable to query: '.db_error());
		$stat_msg = lmsg('RA__msg_err').db_error();
	}
	
/*	if (false == delete_sb_host($host_str)){
		$stat_msg .= lmsg('RA__msg_err_del_host').$host_str;
		continue;
	}
*/

}



function sbm_add_reseller ($sb_domain, $sb_ftp_user, $sb_passwd, $sites_limit = "-1")
{
	global $session;
	$curr_skin = 'default';
	$lang = $session->getParam(SPN_LOCALE) ? str_replace('-', '_', $session->getParam(SPN_LOCALE)) : "en_US";
	$reseller = new RA_Resellers();
	$par = &$reseller->data[NEW_ID];
	$par['DOMAIN'] = $sb_domain;
	$par['EMAIL'] = 'please@specify.email';
	$par['NAME'] = "PSAReseller";
	$par['LOGIN']	=	$sb_ftp_user."@".$sb_domain;
	$par['SKIN']	=	$curr_skin;
	$par['LANGUAGE'] = $lang;
	$par['PSWD'] = $sb_passwd;
	$par['PSWD_CONF'] = $sb_passwd;
	$par['HOSTS'] = $sb_domain;
	$par['LIMIT_SITES'] = $sites_limit;
	$par['LIMIT_HOSTS'] = 1;
	$reseller->add();
	return $reseller;
}


function sbm_delete_resellers ($sb_ftp_login)
{
	$reseller = new RA_Resellers();
	$reseller->delete($sb_ftp_login);
	return $reseller;
}

function sbm_create_button($dom_name, $url)
{
	$img_path = PRODUCT_ROOT.'/admin/htdocs/modules/sbm2/images/icon.gif';
	$cb_tool =PRODUCT_ROOT."/bin/custombutton.sh";
	$rst=`$cb_tool --create -owner "$dom_name" -place "domain" -text "Remote Admin for SiteBuilder2" -url "$url" -conhelp "Click here to manage your SiteBuilder" -file $img_path -internal "true"`;
	$rst=`$cb_tool --create -owner "$dom_name" -place "navigation" -text "Remote Admin for SiteBuilder2" -url "$url" -conhelp "Click here to manage your SiteBuilder" -file $img_path -internal "true"`;

	if ($rst)
		return $rst;
	else
		return false;
}

function get_reseller_id($domain_id)
{
	global $stat_msg;
	global $server;
	$reseller_id = '';
	$query = "SELECT id FROM ".RA_TBL_RESELLERS." WHERE sb_server_id ='".$server['id']."' AND domain_id = '".$domain_id."';";
	$reseller_id = sbm_string_query($query);

	if ($reseller_id != '')
		return $reseller_id;
	else
		return false;
}

function get_reseller_sb_login($dom_id)
{
	global $server;
	$query = "SELECT sb_login FROM ".RA_TBL_RESELLERS." WHERE domain_id='$dom_id' AND sb_server_id = '".$server['id']."';";
	$login = sbm_string_query($query);
	if ($login != "")
		return $login;
	else
		return false;
}

function get_reseller_domain_id($login)
{
	global $server;
	$query = "SELECT domain_id FROM ".RA_TBL_RESELLERS." WHERE sb_login='$login' AND sb_server_id = '".$server['id']."';";
	$login = sbm_string_query($query);
	if ($login != "")
		return $login;
	else
		return false;
}

include_once(PRODUCT_ROOT."/admin/plib/modules/sbm2/RA_domains.php");

?>